<?php
/*****************************************************************************/
/* Packer.php                                                                */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

class Packer
{
	var $filename;
	var $fp;

	function Packer($fn)
	{
		$this->filename = $fn;
	}

	function addFiles($files, $root, $new = true)
	{
		if ($new)
			$this->fp = fopen($this->filename,"wb");
		else
			$this->fp = fopen($this->filename,"ab");
		for ($i=0 ; $i < count($files) ; ++$i)
		{
			$fullfilename = $files[$i];
			if (is_dir($fullfilename))
				$this->processdir($fullfilename, $root);
			else
			{
				$size = filesize($fullfilename);
				$time = filemtime($fullfilename);
				echo "$txt[package34] $fullfilename ...\n";
				// Write file to archive
				$file = fopen($fullfilename, "rb");
				$buffer = fread($file, $size);
				fclose($file);
				fwrite($this->fp, 'file|^|'.str_replace($root."/","",$fullfilename).'|^|'.strlen($buffer).'|^|'.$time."\n");
				fwrite($this->fp, $buffer, $size);
			}
		}
		fclose($this->fp);
	}

	function processdir($name, $root)
	{
		if ($name != $root)
			fputs($this->fp, 'dir|^|'.str_replace($root."/", "", $name)."\n");
		$dir = @opendir($name) or die("Nope");
		while ($file = readdir($dir))
		{
			if ($file == "." || $file == "..")
				continue;
			$fullfilename = $name."/".$file;
			if (is_dir($fullfilename))
				$this->processdir($fullfilename, $root);
			else
			{
				$size = filesize($fullfilename);
				$time = filemtime($fullfilename);
				echo "$txt[package34] $fullfilename ...\n";
				// Write file to archive
				$file = fopen($fullfilename, "rb");
				$buffer = fread($file, $size);
				fclose($file);
				fwrite($this->fp, 'file|^|'.str_replace($root."/","",$fullfilename).'|^|'.strlen($buffer).'|^|'.$time."\n");
				fwrite($this->fp, $buffer, $size);
			}
		}
		closedir($dir);
	}

	function extract($directory, $prefix = "", $overwrite = false)
	{
		$output = "";
		$this->fp = fopen($this->filename, "rb");
		while (!feof($this->fp))
		{
			$data = explode('|^|', chop(fgets($this->fp, 4086)));
			if (count($data) < 2)
				break;
			$filename = $directory."/".$data[1];
			if (ereg("^".quotemeta($prefix), $data[1]))
			{
				if ($data[0] == "dir" && !file_exists($filename) && $data[1] != ".")
				{
					mkdir($filename, 0777);
					@chmod($filename, 0777);
				}
				if ($data[0] == "file")
				{
					if (file_exists($filename) && filemtime($filename) >= $data[3] && !$overwrite)
					{
						$buffer = fread($this->fp, $data[2]);
						$output .= "$txt[package35]$filename$txt[package36]\n";
					}
					else
					{
						$buffer = fread($this->fp, $data[2]);
						$fp = fopen($filename, "wb");
						fputs($fp, $buffer, $data[2]);
						fclose($fp);
						@chmod($filename, 0666);
						@touch($filename, $data[3]);
						$output .= "$txt[package31]$filename ...\n";
					}
				}
			}
			else
			{
				if ($data[0] == "file")
					$buffer = fread($this->fp, $data[2]);
			}
		}
		fclose($this->fp);
		return $output;
	}

	function listFiles()
	{
		$files = array();
		$this->fp = fopen($this->filename, "rb");
		while (!feof($this->fp))
		{
			$data = explode('|^|', chop(fgets($this->fp, 4086)));
			if ($data[0] == "file")
			{
				$id = count($files);
				$files[$id]['name'] = $data[1];
				$files[$id]['size'] = $data[2];
				$buffer = fread($this->fp, $data[2]);
			}
		}
		fclose($this->fp);
		return $files;
	}
}
?>